HDOJ 1507 Uncle Tom's Inherited Land*

直接对每个格子进行dfs结果除以2可以得到答案但是有大量重复的结果,不好输出答案.

可以只对横纵坐标相加是奇数的格子dfs....

Uncle Tom‘s Inherited Land*

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 1728    Accepted Submission(s): 723

Special Judge

Problem Description

Your old uncle Tom inherited a piece of land from his great-great-uncle. Originally, the property had been in the shape of a rectangle. A long time ago, however, his great-great-uncle decided to divide the land into a grid of small squares. He turned some of
the squares into ponds, for he loved to hunt ducks and wanted to attract them to his property. (You cannot be sure, for you have not been to the place, but he may have made so many ponds that the land may now consist of several disconnected islands.)

Your uncle Tom wants to sell the inherited land, but local rules now regulate property sales. Your uncle has been informed that, at his great-great-uncle‘s request, a law has been passed which establishes that property can only be sold in rectangular lots the
size of two squares of your uncle‘s property. Furthermore, ponds are not salable property.

Your uncle asked your help to determine the largest number of properties he could sell (the remaining squares will become recreational parks).

Input

Input will include several test cases. The first line of a test case contains two integers N and M, representing, respectively, the number of rows and columns of the land (1 <= N, M <= 100). The second line will contain an integer K indicating the number of
squares that have been turned into ponds ( (N x M) - K <= 50). Each of the next K lines contains two integers X and Y describing the position of a square which was turned into a pond (1 <= X <= N and 1 <= Y <= M). The end of input is indicated by N = M = 0.

Output

For each test case in the input your program should first output one line, containing an integer p representing the maximum number of properties which can be sold. The next p lines specify each pair of squares which can be sold simultaneity. If there are more
than one solution, anyone is acceptable. there is a blank line after each test case. See sample below for clarification of the output format.

Sample Input

4 4
6
1 1
1 4
2 2
4 1
4 2
4 4
4 3
4
4 2
3 2
2 2
3 1
0 0

Sample Output

4
(1,2)--(1,3)
(2,1)--(3,1)
(2,3)--(3,3)
(2,4)--(3,4)

3
(1,1)--(2,1)
(1,2)--(1,3)
(2,3)--(3,3)

Source

South America 2002 - Practice

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

const int dir_x[4]={-1,1,0,0};
const int dir_y[4]={0,0,-1,1};

int mp[120][120];
int n,m,k;

bool used[120][120];
int linker[120][120];

bool dfs(int x,int y)
{
    for(int i=0;i<4;i++)
    {
        int X=x+dir_x[i];
        int Y=y+dir_y[i];
        if(mp[X][Y]==1) continue;
        if(X>n||X<1||Y>m||Y<1) continue;
        if(used[X][Y]) continue;
        used[X][Y]=true;
        if(linker[X][Y]==-1||dfs(linker[X][Y]/1000,linker[X][Y]%1000))
        {
            linker[X][Y]=x*1000+y;
            return true;
        }
    }
    return false;
}

int hungary()
{
    int ret=0;
    memset(linker,-1,sizeof(linker));
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if((i+j)&1||mp[i][j]==1) continue;
            memset(used,false,sizeof(used));
            if(dfs(i,j)) ret++;
        }
    }
    return ret;
}

int main()
{
    while(scanf("%d%d",&n,&m)!=EOF&&n&&m)
    {
        scanf("%d",&k);
        memset(mp,0,sizeof(mp));
        for(int i=0;i<k;i++)
        {
            int a,b;
            scanf("%d%d",&a,&b);
            mp[a][b]=1;
        }
        printf("%d\n",hungary());
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                int ii=linker[i][j]/1000; int jj=linker[i][j]%1000;
                if(jj!=-1)
                printf("(%d,%d)--(%d,%d)\n",i,j,ii,jj);
            }
        }
    }
    return 0;
}

HDOJ 1507 Uncle Tom's Inherited Land*

时间: 2024-08-04 17:10:24

HDOJ 1507 Uncle Tom's Inherited Land*的相关文章

hdu 1507 Uncle Tom&#39;s Inherited Land*(二分)

Uncle Tom's Inherited Land* Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1853    Accepted Submission(s): 769 Special Judge Problem Description Your old uncle Tom inherited a piece of land fr

HDU 1507 Uncle Tom&#39;s Inherited Land*

Uncle Tom's Inherited Land* Special Judge Problem Description Your old uncle Tom inherited a piece of land from his great-great-uncle. Originally, the property had been in the shape of a rectangle. A long time ago, however, his great-great-uncle deci

HDU——T 1507 Uncle Tom&#39;s Inherited Land*

http://acm.hdu.edu.cn/showproblem.php?pid=1507 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3671    Accepted Submission(s): 1554Special Judge Problem Description Your old uncle Tom inherited

HDU 1507 Uncle Tom&#39;s Inherited Land*(二分图匹配)

Uncle Tom's Inherited Land* Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3339    Accepted Submission(s): 1394Special Judge Problem Description Your old uncle Tom inherited a piece of land fro

HDU 1507 Uncle Tom&#39;s Inherited Land*(二分匹配,输出任意一组解)

<p style="margin: 10px auto; line-height: 19.5px; font-size: 13px; font-family: Verdana, Geneva, Arial, Helvetica, sans-serif; background-color: rgb(40, 85, 126);"> 要输出任意一组解.</p><p style="margin: 10px auto; line-height: 19.5p

HDOJ 1507 Uncle Tom&amp;#39;s Inherited Land*

直接对每一个格子进行dfs结果除以2能够得到答案可是有大量反复的结果,不好输出答案. 能够仅仅对横纵坐标相加是奇数的格子dfs.... Uncle Tom's Inherited Land* Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1728    Accepted Submission(s): 723 Special Judge

hdu Uncle Tom&#39;s Inherited Land*(1*2矩阵覆盖,最大匹配)

http://acm.hdu.edu.cn/showproblem.php?pid=1507 大致题意:在一个n*m的格子上,黑色的地方不可用,问在白色格子上最多可放多少1*2的矩阵. 思路:建图,每个白色格子与它临近的上下左右的白色格子建边,求最大匹配,答案为最大匹配/2,因为是双向图.最后输出匹配边时,当找到一组匹配边记得将该边标记,以防重复计算. #include <stdio.h> #include <algorithm> #include <set> #inc

ZOJ1516 Uncle Tom&#39;s Inherited Land(二分图最大匹配)

一个经典的构图:对格子进行黑白染色,黑白的点分别作XY部的点. 这一题的边就是可以出售的单位面积2的土地,边的端点就是这个土地占用的X部和Y部的两个点. 这样就建好二分图,要求最多土地的答案显然是这个二分图的最大边独立集,也就是最大匹配. 1 #include<cstdio> 2 #include<cstring> 3 #include<algorithm> 4 #include<queue> 5 using namespace std; 6 #define

ZOJ 1516 Uncle Tom&#39;s Inherited Land

题目大意: 除去那些作为荷塘的土地块,将剩余的土地希望每次将两块相邻的地一起卖出,最多能卖出多少种这样的由相邻土地 合成的长方形土地块 很明显的二分图问题,但是要考虑如何建模 一个长方形土地总是由相邻的两块地组成,那么我们就将相邻的两块地一块放在X集合,一块放在Y集合 所有放在X集合中的土地互不影响(也就是任意两个在X中的土地不形成长方形) 那么我们可以看作土地上 0101010 1010101 0101010 1010101 比如这样标注的,那么0所对应的空地就放入集合X,并不断添加一个X的标